"""validationMessages -- cleanup Archetypes/validation messages"""

__author__  = 'Steve McMahon <steve@dcn.org>'
__docformat__ = 'plaintext'

# Messages taken from godchap's gotcha-validation-i18n branch of
# archetypes validation

from Products.PloneFormGen import HAS_PLONE25

if HAS_PLONE25:

    # We're only going to do this for Plone 2.5+

    import zope.i18n

    from Products.PloneFormGen import PloneFormGenMessageFactory as _

    import re
    from types import StringTypes

    verrorRE = re.compile("Validation failed\((.+)\):")

    newMessages = {
        'isDecimal' :   _(u'pfg_isDecimal', u'This field requires a decimal value.'),
        'isInt' :       _(u'pfg_isInt', u'This field requires an integer value.'),
        'isPrintable' : _(u'pfg_isPrintable', u'This value contains unprintable characters.'),
        'isSSN' :       _(u'pfg_isSSN', u'This is not a well formed SSN.'),
        'isUSPhoneNumber' : _(u'pfg_isUSPhoneNumber', u'This is not a valid us phone number.'),
        'isInternationalPhoneNumber' : _(u'pfg_isInternationalPhoneNumber', u'This is not a valid international phone number.'),
        'isZipCode' :   _(u'pfg_isZipCode', u'This is not a valid zip code.'),
        'isURL' :       _(u'pfg_isURL', u'This is not a valid url.'),
        'isEmail' :     _(u'pfg_isEmail', u'This is not a valid email address.'),
        'isMailto' :    _(u'pfg_isMailto', u'This is not a valid mailto: url.'),
        'isUnixLikeName' : _(u'pfg_isUnixLikeName', u'This name is not a valid identifier.'),
        'isChecked' :   _(u'pfg_isChecked', u'This box must be checked.'),
        'isUnchecked' :   _(u'pfg_isUnchecked', u'This box must be unchecked.'),
        }
        
    newRequiredMessage = _(u'pfg_isRequired', u'This field is required.')

    def cleanupMessage(original, context):

        if type(original) in StringTypes:
            if original.find('is required, please correct.') > 0:
                return zope.i18n.translate(newRequiredMessage, context)
            else:
                mo = verrorRE.match(original)
                if mo:
                    nm = newMessages.get(mo.groups()[0])
                    if nm:
                        return zope.i18n.translate(nm, context)

        return original

else:
    # don't have Plone 2.5+; don't do anything

    def cleanupMessage(original, context):
        return original

